#include "physics.h"

#include "internal.h"
#include "internal/physics.h"

namespace kek::Physics {

void init() {
	kekData.physics = new PhysicsData();

	btDefaultCollisionConfiguration *collisionConf = new btDefaultCollisionConfiguration();
	btCollisionDispatcher *dispatcher = new btCollisionDispatcher(collisionConf);
	btBroadphaseInterface *overlappingPairCache = new btDbvtBroadphase();
	btSequentialImpulseConstraintSolver *solver = new btSequentialImpulseConstraintSolver();
	kekData.physics->world = new btDiscreteDynamicsWorld(dispatcher, overlappingPairCache, solver, collisionConf);
	kekData.physics->world->setGravity(btVector3(0, -10, 0));

	btCollisionShape *shape = new btBoxShape(btVector3(1, 1, 1));
	btDefaultMotionState *state = new btDefaultMotionState();
	btRigidBody *body = new btRigidBody(1, state, shape);
	kekData.physics->world->addRigidBody(body);
}

void destroy() {
	delete kekData.physics;
}

void step(float deltaT) {
	kekData.physics->world->stepSimulation(deltaT, 100);

	//btRigidBody *body = btRigidBody::upcast(kekData.physics->world->getCollisionObjectArray()[0]);
	//btTransform &t = body->getWorldTransform();
	//btVector3 &vec = t.getOrigin();
}

}
